<?php

/**
 * jDownloads SEF extension for Joomla!
 *
 * @copyright   2009 JoomAce
 * @license     http://www.joomace.net/company/license
 * www.joomace.net
 * @package     sh404SEF
 *
 * Modified by Arno Betz (http://www.jDownloads.com) so it works with jDownloads v1.6 stable
 * Version 1.6  2010-03-11
 * Version 1.8  2011-05-24
 *
 * Modified by yoonique[.net]
 */
defined('_JEXEC') or die('Direct Access to this location is not allowed.');

// ------------------  standard plugin initialize function - don't change ---------------------------
global $sh_LANG;
$sefConfig = & shRouter::shGetConfig();
$shLangName = '';
$shLangIso = '';
$title = array();
$shItemidString = '';
$dosef = shInitializePlugin($lang, $shLangName, $shLangIso, $option);
if ($dosef == false)
	return;
// ------------------  standard plugin initialize function - don't change ---------------------------
// ------------------  load language file - adjust as needed ----------------------------------------
//	$shLangIso = shLoadPluginLanguage( 'com_jdownloads', $shLangIso, '_SH404SEF_JD_HOME');
// ------------------  load language file - adjust as needed ----------------------------------------

global $jDownloads_MenuTitle;
global $jDownloads_Categories;
global $jDownloads_DownloadId;
global $jDownloads_CategoryId;
/* jDownloads */
$jDownloads_MenuTitle = true;
/* if 0, no categories will be inserted in URL for a download
  if 1, only 'last' category will be inserted in URL
  if 2, all nested categories will be inserted in URL */
$jDownloads_Categories = 2;
/* if true, id will be prepended to name */
$jDownloads_DownloadId = false;
$jDownloads_CategoryId = false;

if (!function_exists('getJdCatTitle')) {

	function getJdCatTitle($id, $option, $shLangName) {
		global $jDownloads_MenuTitle;
		global $jDownloads_Categories;
		global $jDownloads_DownloadId;
		global $jDownloads_CategoryId;
		$sefConfig = & shRouter::shGetConfig();
		$categories = array();

		if (empty($jDownloads_Categories))
			$id = 0;
		while ($id > 0) {
			$database = & JFactory::getDBO();
			$database->setQuery('SELECT cat_id, cat_title, parent_id FROM #__jdownloads_cats WHERE cat_id =' . $id);
			if (!shTranslateUrl($option, $shLangName))
				$rows = $database->loadRow(false);
			else
				$rows = $database->loadRow();

			$name = ($jDownloads_CategoryId ? $id . $sefConfig->replacement : '') . $rows[1];
			array_unshift($categories, $name);
			$id = $rows[2];
			if ($jDownloads_Categories == '1')
				break;
		}
		return $categories;
	}

}

if (!function_exists('getJdItemTitle')) {

	function getJdItemTitle($id, $option, $shLangName) {
		global $jDownloads_MenuTitle;
		global $jDownloads_Categories;
		global $jDownloads_DownloadId;
		global $jDownloads_CategoryId;
		$sefConfig = & shRouter::shGetConfig();

		$database = & JFactory::getDBO();
		$database->setQuery('SELECT file_id, file_title, cat_id FROM #__jdownloads_files WHERE file_id = ' . $id);
		if (!shTranslateUrl($option, $shLangName))
			$rows = $database->loadRow(false);
		else
			$rows = $database->loadRow();

		$category = getJdCatTitle($rows[2], $option, $shLangName);
		$name = ($jDownloads_DownloadId ? $id . $sefConfig->replacement : '') . $rows[1];
		array_push($category, $name);

		return $category;
	}

}

if (empty($Itemid) && $sefConfig->shInsertGlobalItemidIfNone && !empty($shCurrentItemid)) {
	$string .= '&Itemid=' . $shCurrentItemid;
	$Itemid = $shCurrentItemid;
	shAddToGETVarsList('Itemid', $Itemid);
}

$view = isset($view) ? $view : null;
$Itemid = isset($Itemid) ? $Itemid : null;
$limit = isset($limit) ? $limit : null;
$limitstart = isset($limitstart) ? $limitstart : null;

// insert component name from menu
$shJdName = shGetComponentPrefix($option);
$shJdName = empty($shJdName) ? getMenuTitle($option, null, $Itemid, null, $shLangName) : $shJdName;
$shJdName = (empty($shJdName) || $shJdName == '/') ? 'Downloads' : $shJdName; // V 1.2.4.t
if ($jDownloads_MenuTitle && !empty($shJdName))
	$title[] = $shJdName;

if (isset($view)) {
	switch ($view) {
		case 'viewcategories':
			if (!$jDownloads_MenuTitle)
				$title[] = $view;
			break;
		case 'viewcategory':
			if (isset($catid))
				$title = array_merge($title, getJdCatTitle($catid, $option, $shLangName));
			break;
		case 'viewdownload':
			if (isset($cid))
				$title = array_merge($title, getJdItemTitle($cid, $option, $shLangName));
			break;
		case 'summary':
			if (isset($cid))
				$title = array_merge($title, getJdItemTitle($cid, $option, $shLangName));
			$title[] = JText::_('JLIST_FRONTEND_HEADER_SUMMARY_TITLE');
			break;
		case 'finish':
			if (isset($cid))
				$title = array_merge($title, getJdItemTitle($cid, $option, $shLangName));
			$title[] = JText::_('JLIST_FRONTEND_HEADER_FINISH_TITLE');
			break;
		case 'search':
			$tasks = array('search' => JText::_('JLIST_FRONTEND_SEARCH_LINKTEXT'));
			$title[] = $tasks[$view];
			break;
		case 'upload':
			$tasks = array('upload' => JText::_('JLIST_FRONTEND_UPLOAD_LINKTEXT'));
			$title[] = $tasks[$view];
			break;
		default:
			$title[] = $view;
	}
}

shRemoveFromGETVarsList('cid');
shRemoveFromGETVarsList('catid');
shRemoveFromGETVarsList('m');
shRemoveFromGETVarsList('view');

shRemoveFromGETVarsList('option');
shRemoveFromGETVarsList('lang');
if (!empty($Itemid))
	shRemoveFromGETVarsList('Itemid');
if (!empty($limit))
	shRemoveFromGETVarsList('limit');
if (isset($limitstart))
	shRemoveFromGETVarsList('limitstart');

// ------------------  standard plugin finalize function - don't change ---------------------------
if ($dosef) {
	$string = shFinalizePlugin($string, $title, $shAppendString, $shItemidString, (isset($limit) ? @$limit : null), (isset($limitstart) ? @$limitstart : null), (isset($shLangName) ? @$shLangName : null));
}
	// ------------------  standard plugin finalize function - don't change ---------------------------

